% return the interpolated value of the data, based on cubic
% interpolation through the four equally spaced data function value
% points.
% u is the fractional distance from the x position of v1 for which the
% value is to be returned.
function v = cubic(v0,v1,v2,v3,u)

v = ( (v1) + (u) * ( ...
       0.5 * ((v2)-(v0)) + (u) * ( ...
       (v0) - 2.5 * (v1) + 2.0 * (v2) - 0.5 * (v3) + (u) * ( ...
       -0.5 * (v0) + 1.5 * (v1) - 1.5 * (v2) + 0.5 * (v3)  ) ...
                                 ) ...
                    ) ...
     ); 


